/***
  * The contents of this file are subject to the Mozilla Public
  * License Version 1.1 (the "License"); you may not use this file
  * except in compliance with the License. You may obtain a copy of
  * the License at http://www.mozilla.org/MPL/
  * 
  * Software distributed under the License is distributed on an "AS
  * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
  * implied. See the License for the specific language governing
  * rights and limitations under the License.
  * 
  * The Original Code in this file as it was released publicly upon
  * October 30, 2004 after being tested for several months by a 
  * bunch of CSS co-workers. Thanks guys ;)
  * 
  * The Initial Developer of the Original Code is HJ van Rantwijk.
  * all Portions created by HJ van Rantwijk are Copyright (C) 2004-2005
  * by HJ van Rantwijk. All Rights Reserved.
  * 
  * All rats will be shot, and survivors will be shot again, so
  * credit to who credit belongs, or else...you sucker!
  * 
  * Contributors:
  *   Michael Vincent van Rantwijk <mv_van_rantwijk@yahoo.com>
  *
  */

var markupFixup = [
	[ /(&#151|&amp;#151|&mdash|&amp;mdash);/g,	"&#8212;" ],
	[ /&quot;/g,								"&#39;" ],
	[ /&lsquo;/g,								"&#8216;" ],
	[ /&rsquo;/g,								"&#8217;" ],
	[ /&ldquo;/g,								"&#8220;" ],
	[ /&rdquo;/g,								"&#8221;" ],
	[ /&trade;/g,								"&#8482;" ],
	[ /&nbsp;/g,								"<br />" ],
	/* [ /([ |\w])&((?![#|amp;])[\w| ])/g,	 		"$1&amp;$2" ],				// "&#151; 123&456 & abc&def 123&abd abc&123 abc&amp;def" */
	[ /(src=|src=(?![\"|\']))/g,				"src=\"" ],
	[ /(href=|href=(?![\"|\']))/g,				"href=\"" ],
	[ / *>/g,									"\">" ],
	[ / *\/>/g,								"\" />" ],
	[ /<(br|hr|img)([^>]*[^\/]|)>/g,			"<$1$2 />" ],
    [ /< *br clear=(left|right|all|none) \/>/g,	"<br clear=\"$1\" />" ],	// temporarily hack!
	[ /(\n|\t|\r|\f)/g,							" " ]						// white space need special handling!
];

var smileys = [
	[ /\s(&gt;[-^v]?)\)/g,			"alien" ],
	[ /\s(&gt;[=:;][-^v]?)[(|]/g,	"angry" ],
	[ /\s([:][-]?)[Ss]/g,			"confused" ],
	[ /\s([B8][-^v]?)[)\]]/g,		"cool" ],
	[ /\s([=:;][~'][-^v]?)\(/g,		"cry" ],
	[ /\so[._]O/g,					"dizzy" ],
	[ /\sO[._]o/g,					"dizzy-back" ],
	[ /\so[._]o|O[._]O/g,			"eek" ],
	[ /\s(&gt;[=:;][-^v]?)D/g,		"evil" ],
	[ /\s([=:;][-^v]?)DD/g,			"lol" ],
	[ /\s([=:;][-^v]?)D/g,			"laugh" ],
	[ /\s[xX]?-D/g,					"rofl" ],
	[ /\s([=:;][-^v]?)\|/g,			"normal" ],
	[ /\s([=:;][-^v]?)\?/g,			"question" ],
	[ /\s[=:;]"[)\]]/g,				"red" ],
	[ /\s9[._]9/g,					"rolleyes" ],
	[ /\s([=:;][-^v]?)[(\[]/g,		"sad" ],
	[ /\s([=:][-^v]?)[)\]]/g,		"smile" ],
	[ /\s([=:;][-^v]?)[0oO]/g,		"surprised" ],
	[ /\s([=:;][-^v]?)[pP]/g,		"tongue" ],
	[ /\s;[-]?\)/g,					"wink" ]
];

function delayedInsert(aIndex, aLength)
{
  mzFeedViewer.addContentToBoxes(aIndex, aLength);
}

var mzFeedViewer =
{
  XHTML_NS: "http://www.w3.org/1999/xhtml",
  itemList: null,
  keys: null,
  articleIndex: 0,

  init: function()
  {
    var displayMilitaryTime = false;

    this.itemList = new Array();
    this.keys = new Array();

    // Items are build up by <div> elements so get all of them
    var divs = document.getElementsByTagNameNS(this.XHTML_NS, "div");

    // Not all divs are items so we have to check them first
    for (var i = 0; i < divs.length; i++) {
      if (divs[i].getAttribute("class") == "article") {
        // Item found, so lets convert the date in the same run
        var date = divs[i].getAttribute("date");
        // Not all items have a date, so we also have to check the date
        if (date)
          divs[i].childNodes[1].textContent = this.getPrettyDate(date, displayMilitaryTime);
       // Keep this item for further use
       this.itemList.push(divs[i]);
      }
      if (i == 3) {
        var keys = divs[i].getAttribute("keys");

        for (var kIndex = 0; kIndex < keys.length; kIndex++) {
          var key = keys.charCodeAt(kIndex);
          this.keys.push(key);
        }
      }
    }
    var numberOfItems = (this.itemList.length);
    /***
      * By now we have collected all items, and converted the dates to a more appealing 
      * one, and now it's time to initialize the three navigation buttons/images.
      */
    this.initItemBoxes();   
    /***
      * The list with items might be very long, and that might take ages to finish, 
      * so we do an initial run with a only a limited number of items to give people 
      * the 'impression' that something is done, and done fast ;)
      */
    this.markupErrors = 0;
    var items = (numberOfItems < 6) ? numberOfItems : 5;
    this.insertContent(0, items);
    setTimeout(delayedInsert, 0, items, numberOfItems);
  },

  onclick: function(aEvent)
  {
    var target = aEvent.target;

    if (target.className.match(/^subscribeButton/))
      return;

    if (target instanceof HTMLImageElement) {
      if (target.hasAttribute("disabled"))
        return;

      var currentIndex;
      var index = target.parentNode.index;
      var articles = target.parentNode.articles;
      var showArticle = (target.className != "toggleButton");

      if (window.location.href.match(/#article-/))
        currentIndex = Number(window.location.href.replace(/.*#article-/, ""));

      switch(target.className) {
        case "previous":
          if (currentIndex && currentIndex > 0)
            index = currentIndex - 1;
          else if (index > 1)
            index--;
          /* go up based on the button index!
          if (index > 1)
            index--;
          if (currentIndex && currentIndex == index)
            if (index > 1)
              index--; */
            break;
        case "next":
          if (currentIndex && currentIndex < articles)
            index = currentIndex + 1;
          else if (index < articles)
            index++;
          /* go down based on the button index!
          if (index < articles)
            index++;
          if (currentIndex && currentIndex == index)
            if (index < articles)
              index = currentIndex + 1; */
          break;
        case "top":
          index = 1;
          break;
        case "toggleButton":
          var type = target.getAttribute("type");
          target.style.display = "none";
          var contentBox = target.parentNode.nextSibling;
          var isText = (type == "text");
          target.setAttribute("type", isText ? "markup" : "text");
          contentBox.textContent = isText ? contentBox.markup : contentBox.text; // markup.replace(/<([^>]*)>/g, "");
          target.style.display = "block";
          break;
      }
      if (showArticle)
        window.location.href = (index == -1) ? window.location.href.replace(/#article-*/, "") : "#article-" + String(index);
    }
  },

  onkeyup: function(aEvent)
  {
    var key = aEvent.keyCode;
    var refresh = false;
    var currentIndex;
    var keys = mzFeedViewer.keys;
    var index = mzFeedViewer.articleIndex;
    var articles = (mzFeedViewer.itemList.length -1);

    if (window.location.href.match(/#article-/))
      currentIndex = Number(window.location.href.replace(/.*#article-/, ""));

    if (key == keys[0]) { // Previous Article
      if (currentIndex && currentIndex > 0) {
        index = currentIndex - 1;
        refresh = true;
      }
      else if (index > 1) {
        index--;
        refresh = true;
      }
    }
    else if (key == keys[1]) { // Next Article
      if (currentIndex && currentIndex < articles) {
        index = currentIndex + 1;
        refresh = true;
      }
      else if (index < articles) {
        index++;
        refresh = true;
      }
    }
    else if (key == keys[2]) { // First Article
      index = 0;
      refresh = true;
    }
    else if (key == keys[3]) { // Subscribe to Feed
      dump("\nkey S: " + key);
    }
    if (refresh) {
      window.location.href = (index == -1) ? window.location.href.replace(/#article-*/, "") : "#article-" + String(index);
      mzFeedViewer.articleIndex = index;
      refresh = false;
    }
  },

  /***
    * Copied from Mozilla Thunderbird but renamed and slightly modified
    */
  convertDate: function(dateString)
  {  
    var parts = dateString.match(/(\d\d\d\d)(-(\d\d))?(-(\d\d))?(T(\d\d):(\d\d)(:(\d\d)(\.(\d+))?)?(Z|([+-])(\d\d):(\d\d))?)?/);
    var date = new Date(parts[1], parts[3]-1, parts[5], parts[7] || 0, parts[8] || 0, parts[10] || 0, parts[12] || 0);
    var remoteToUTCOffset = 0;

    if (parts[13] && parts[13] != "Z") {
      var direction = (parts[14] == "+" ? 1 : -1);
      if (parts[15])
        remoteToUTCOffset += direction * parts[15] * 3600000;
      if (parts[16])
        remoteToUTCOffset += direction * parts[16] * 60000;
    }
    remoteToUTCOffset = remoteToUTCOffset * -1;
    var UTCToLocalOffset = date.getTimezoneOffset() * 60000;
    UTCToLocalOffset = UTCToLocalOffset * -1;
    date.setTime(date.getTime() + remoteToUTCOffset + UTCToLocalOffset);
    return date.toUTCString();
  },
  
  getPrettyDate: function(aDateString, displayMilitaryTime)
  {
    var aDate;
    var retValue = "";

    if (aDateString.search(/^\d\d\d\d/) != -1) {
      aDate = this.convertDate(aDateString);
      aDateString = aDate;
    }
    aDate = new Date(aDateString.replace(/BST|IST$/, "GMT +0100"));

    if (aDate == "Invalid Date") {
      // This is an experimental code snippet but I still needs to finish it!
      var parts = aDateString.match(/^((Mon|Tue|Wed|Thu|Fri|Sat|Sun), *)?(\d\d)? +(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) +(\d\d|\d\d\d\d)? +(\d\d:\d\d:\d\d)? +([+-]?\d\d\d\d|UT|GMT|EST|EDT|CST|CDT|MST|MDT|PST|PDT|\w)$/);

      if (parts) {
        if (parts[5].length == 2) 
          parts[5] = "20" + parts[5];
        aDate = new Date(parts[3] +" "+ parts[4] +" "+ parts[5] +" "+ parts[6] +" "+ parts[7]);
      }
    }
    if (aDate instanceof Date) {
      var dayString;
      var currentDate = new Date();
      var currentDay = currentDate.getUTCDate();
      var publishedDate = aDate; // new Date(aDate);
      var publishedDay = publishedDate.getUTCDate();

      if (currentDay == publishedDay)
        dayString = "Today";
      else if (currentDay == (publishedDay + 1))
        dayString = "Yesterday";
      else {
        dayString = publishedDate.toUTCString();
        dayString = dayString.substring(0, 11);
      }
      var addition = "";
      var timeString = "";
      var hours = publishedDate.getUTCHours();
      var minutes = publishedDate.getUTCMinutes();

      if (!displayMilitaryTime) {
        if (minutes == 0) {
          if (hours == 12)
            timeString = "Noon";
          else if (hours == 0)
            timeString = "Midnight";
        }
        if (timeString == "") {
          if (hours >= 0 && (hours <= 11 && minutes <= 59))
            addition = "AM";
          else {
            addition = "PM";

            if (hours > 12)
              hours -= 12;
          }
          function padZeros(num) {
            return num < 10 ? "0" + num : num;
          }
          timeString = padZeros(hours) + ":" + padZeros(minutes) + " " + addition;
        }
      }
      retValue = (dayString + " @ " + timeString);
    }
    return retValue;
  },

  isValidRFC822Date: function(aDateString)
  {
    // Date validator for RSS feeds
    const FZ_RFC822_RE = "^(((Mon)|(Tue)|(Wed)|(Thu)|(Fri)|(Sat)|(Sun)), *)?\\d\\d?" + 
                         " +((Jan)|(Feb)|(Mar)|(Apr)|(May)|(Jun)|(Jul)|(Aug)|(Sep)|(Oct)|(Nov)|(Dec))" + 
                         " +\\d\\d(\\d\\d)? +\\d\\d:\\d\\d(:\\d\\d)? +(([+-]?\\d\\d\\d\\d)|(UT)|(GMT)" + 
                         "|(EST)|(EDT)|(CST)|(CDT)|(MST)|(MDT)|(PST)|(PDT)|\\w)$";

    var parts = aDateString.match(/^((Mon|Tue|Wed|Thu|Fri|Sat|Sun), *)?(\d\d)? +(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) +(\d\d|\d\d\d\d)? +(\d\d:\d\d:\d\d)? +([+-]?\d\d\d\d|UT|GMT|EST|EDT|CST|CDT|MST|MDT|PST|PDT|\w)$/);
    dump("\nparts-1: " + parts)
    var regex = new RegExp(FZ_RFC822_RE);
    return regex.test(aDateString);
  },

  initItemBoxes: function()
  {
    var articles = this.itemList;
    // We might want to change the XSL to handle most, if not all of this.
    for (var article = 0; article < articles.length; article++) {
      var articleAnchor = articles[article].firstChild;
      var articleID = "article-" + (article + 1);
      articleAnchor.id = articleID;
      articleAnchor.name = articleID;

      var navigationBox = articles[article].childNodes[2];
      navigationBox.articles = (articles.length-1);
      navigationBox.index = (article + 1);
    }
    if (articles.length >= 0) {
      navigationBox = articles[0].childNodes[2];
      navigationBox.firstChild.setAttribute("disabled", "true");
      navigationBox.lastChild.setAttribute("disabled", "true");

      if (articles.length > 1) {
        navigationBox = articles[articles.length-1].childNodes[2];
        navigationBox.childNodes[1].setAttribute("disabled", "true");
      }
    }
  },

  addContentToBoxes: function(aStartIndex, aNumber)
  {
    this.insertContent(aStartIndex, aNumber);

	if (this.markupErrors) {
      var errorSpan = document.getElementById("markupErrors");
      var errorText = (this.markupErrors == 1) ? " unrecoverable markup error" : " unrecoverable markup error(s)";
      errorSpan.textContent = this.markupErrors + errorText;
    }
  },

  /***
    * Michael, this is one of the sections that needs a re-write.
    * See if you can get rid of the first dummyDiv.innerHTML You might 
    * also want to add a new function to handle errors, but make sure 
    * that you test everything 'thoroughly' after you're done!
    */
  insertContent: function(aStartIndex, aNumber)
  {
    var textOrMarkup, markupCheckStage
    var articles = this.itemList;

    for (var article = aStartIndex; article < aNumber; article++) {
      textOrMarkup = articles[article].getAttribute("description");

      if (!textOrMarkup) {
        var mainLink = articles[article].childNodes[3].firstChild.getAttribute("href");
        textOrMarkup = (mainLink) ? "<p><a href=" + mainLink + "\">Link...</a></p>" : "<p>...</p>";
      }
      if (textOrMarkup) {
        // We have content...add the main container...
        var textContainer = document.createElementNS(this.XHTML_NS, "div");
        articles[article].appendChild(textContainer);
        // and add the text container...
        var displayBox = document.createElementNS(this.XHTML_NS, "div");
        displayBox.className = "textContainer";

        try {
          /*** 
            * This is stage one: here we insert the markup without any modifications 
            * and the markup is OK when we don't end up in the catch (well done chap).
            */
          markupCheckStage = 0;
          articles[article].markupCheckStage = 0;
          // This is not an error, but we have to replace this IE-ism for Yahoo!
          if (textOrMarkup.indexOf("#151;") >= 0)
            textOrMarkup = textOrMarkup.replace(markupFixup[0][0], markupFixup[0][1]);
          if (textOrMarkup.indexOf("&quot;") >= 0)
            textOrMarkup = textOrMarkup.replace(markupFixup[1][0], markupFixup[1][1]);
          // if (textOrMarkup.match(/((^|\s)(?:[&gt;]?[B8=:;(xX][~']?[-^v"]?(?:[)|(PpSs0oO\?\[\]\/\\]|D+)|&gt;[-^v]?\)|[oO9][._][oO9])(\s|$))/))
            textOrMarkup = this.insertSmiley(textOrMarkup);
		 
          displayBox.innerHTML = textOrMarkup;
          textContainer.setAttribute("markupCheckStage", "0");
          textContainer.appendChild(displayBox);
        } catch(ex) {
          // dump("\nStage 0 markup error in article: " + article);
          /*** 
            * innertHTML failed, so the markup contains errors, but we need to display 
            * the content anyway. Let's call in the troops to 'fix' the markup errors.
            * Yes, this is a dirty way to do it, but it works...most of the times ;)
            */
          for (fIndex in markupFixup) {
            textOrMarkup = textOrMarkup.replace(markupFixup[fIndex][0], markupFixup[fIndex][1]);
          }
          /*** 
            * We should have fixed the most common markup errors by now, so let's try again.
            * Note: we might need to extend [markupFixup] to catch other errors as well.
            */
          try {
            markupCheckStage = 1;
            displayBox.innerHTML = textOrMarkup;
            textContainer.setAttribute("markupCheckStage", "1");
            textContainer.appendChild(displayBox);
          } catch(ex) {
            // dump("\nStage 1 markup error in article: " + article);
            /*** 
              * Second attempt failed: the markup contains other/unknown and/or 
              * more severe markup errors...now we have to get real dirty (:
              */
            try {
              // XXX: Dad, what is this? Do we (still) need this (at all)?
              // Good question, but I can't remember why!?!
              if (textOrMarkup.indexOf("content-encoded>") >= 0) {
                textOrMarkup = textOrMarkup.replace(/<content-encoded>/g, "");
                textOrMarkup = textOrMarkup.replace(/<\/content-encoded>/g, "");
              }
              var dummyDiv = document.createElementNS(this.XHTML_NS, "div");

              markupCheckStage = 2;
              dummyDiv.innerHTML = textOrMarkup;
              textContainer.setAttribute("markupCheckStage", "2");
            } catch(ex) {
              // dump("\nStage 2 markup error in article: " + article);
              dummyDiv = null;

              try {
                markupCheckStage = 3;
                dummyDiv.innerHTML = textOrMarkup;
              } catch(ex) {
                // dump("\nStage 3 markup error in article: " + article);
                // Markup fix failed, split content into paragraphs
                /* replace <div>'s with <p>'s (why?)
                textOrMarkup = textOrMarkup.replace(/<div([^>]*)>/g, "<p>");
                textOrMarkup = textOrMarkup.replace(/<\/div>/g, "</p>");
                textOrMarkup = textOrMarkup.replace(/<p(?!re)[^\>]*>/ig, "\n");
                textOrMarkup = textOrMarkup.replace(/<\/p>/ig, ""); */
              }
              dummyDiv = null;
            }
            var paragraphs = textOrMarkup.split("\n");

            if (paragraphs.length) {

              for (var pIndex = 0; pIndex < paragraphs.length; pIndex++) {
                textOrMarkup = paragraphs[pIndex];
                var dummy = textOrMarkup.replace(/\s*/g, '');

                if (dummy.length) {
                  /* if (dummy != "<p></p>") {
                    // re-insert the stripped paragraph elements
                    textOrMarkup = "<p>" + textOrMarkup + "</p>";
                  } */
                  if (displayBox == undefined) {
                    displayBox = document.createElementNS(this.XHTML_NS, "div");
                    displayBox.className = "textContainer";
                  }
                  try {
                    markupCheckStage = 4;
                    displayBox.innerHTML = textOrMarkup;
                  } catch(ex) {
                    // dump("\nStage 4 markup error in article: " + article);
                    this.markupErrors++;
                    var errorTab = document.createElementNS(this.XHTML_NS, "span");
                    errorTab.textContent = "Markup error detected!";
                    errorTab.className = "paragraphErrorHeader";

                    var toggleButton = document.createElementNS(this.XHTML_NS, "img");
                    toggleButton.setAttribute("type", "text");
                    toggleButton.id = "toggleButton";
                    toggleButton.className = "toggleButton";
                    toggleButton.title = "Click to toggle Text v.s. Markup";
                    errorTab.appendChild(toggleButton);
                    displayBox.appendChild(errorTab);
                    var contentBox = document.createElementNS(this.XHTML_NS, "p");
                    contentBox.className = "contentBox";
                    var text  = textOrMarkup.replace(/&lt;/g, "<").replace(/&gt;/g, ">");
                    text = text.replace(/<(br|hr) *(\/>)/g, "\n");
                    text = text.replace(/<([^>]*)>/g, "");
                    contentBox.text = text;
                    contentBox.textContent = text;
                    contentBox.markup = textOrMarkup;

                    displayBox.className = "paragraphError";
                    displayBox.appendChild(contentBox);
                  }
                  textContainer.appendChild(displayBox);
                  textContainer.setAttribute("markupCheckStage", String(markupCheckStage));
                  displayBox = undefined;
                }
              }
            }
          }
        }
      }
    }
  },

  insertSmiley: function(textOrMarkup)
  {
    // dump("\ninsertSmiley();");
    for (i in smileys) {
      if (textOrMarkup.search(smileys[i][0]) != -1) {
        // textOrMarkup = textOrMarkup.replace(smileys[i][0], "<img class=\"emotion\" type=\"face-" + smileys[i][1] + "\"/>");
        textOrMarkup = textOrMarkup.replace(smileys[i][0], "<img class=\"emotion\" src=\"chrome://chatzilla/skin/images/face-" + smileys[i][1] + ".png\"/>");
        // dump("\nmatching: " + smileys[i][1]);
      }
    }
    return(textOrMarkup);
  }
};

addEventListener("click", mzFeedViewer.onclick, false);
addEventListener("keyup", mzFeedViewer.onkeyup, false);
